var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _desc, _value, _class, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _desc2, _value2, _class3, _descriptor6;

function _initDefineProp(target, property, descriptor, context) {
	if (!descriptor) return;
	Object.defineProperty(target, property, {
		enumerable: descriptor.enumerable,
		configurable: descriptor.configurable,
		writable: descriptor.writable,
		value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
	});
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
	var desc = {};
	Object['ke' + 'ys'](descriptor).forEach(function (key) {
		desc[key] = descriptor[key];
	});
	desc.enumerable = !!desc.enumerable;
	desc.configurable = !!desc.configurable;

	if ('value' in desc || desc.initializer) {
		desc.writable = true;
	}

	desc = decorators.slice().reverse().reduce(function (desc, decorator) {
		return decorator(target, property, desc) || desc;
	}, desc);

	if (context && desc.initializer !== void 0) {
		desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
		desc.initializer = undefined;
	}

	if (desc.initializer === void 0) {
		Object['define' + 'Property'](target, property, desc);
		desc = null;
	}

	return desc;
}

function _initializerWarningHelper(descriptor, context) {
	throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

import { createFormatFunc } from '../FormatTypes';
import Validation from '../Validation';
import { observable, computed, action, runInAction, isObservableArray } from 'mobx';
import { isEmpty, isArray, isNativeArray, isPlainObject, clone, filtersFlow } from '../utils';

var Actual = (_class = function () {
	function Actual() {
		_classCallCheck(this, Actual);

		_initDefineProp(this, 'pristineValue', _descriptor, this);

		_initDefineProp(this, 'value', _descriptor2, this);

		_initDefineProp(this, 'sourceValue', _descriptor3, this);

		_initDefineProp(this, 'errorMessage', _descriptor4, this);

		_initDefineProp(this, 'checkedStatus', _descriptor5, this);
	}

	/**
  * checked status
  *
  * `-1`: user unchecked, should be `false` as usual
  * `0` : default status, should be `undefined` as usual
  * `1` : user checked, should be `true` as usual
  */


	_createClass(Actual, [{
		key: 'setInitialValue',
		value: function setInitialValue(initialValue) {
			this.pristineValue = initialValue;
			this.sourceValue = initialValue;
			this.value = initialValue;
		}
	}]);

	return Actual;
}(), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'pristineValue', [observable], {
	enumerable: true,
	initializer: null
}), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, 'value', [observable], {
	enumerable: true,
	initializer: null
}), _descriptor3 = _applyDecoratedDescriptor(_class.prototype, 'sourceValue', [observable], {
	enumerable: true,
	initializer: null
}), _descriptor4 = _applyDecoratedDescriptor(_class.prototype, 'errorMessage', [observable], {
	enumerable: true,
	initializer: function initializer() {
		return '';
	}
}), _descriptor5 = _applyDecoratedDescriptor(_class.prototype, 'checkedStatus', [observable], {
	enumerable: true,
	initializer: function initializer() {
		return 0;
	}
})), _class);
var PrimitiveStore = (_class3 = function () {
	_createClass(PrimitiveStore, [{
		key: 'pristineValue',
		get: function get() {
			var pristineValue = this._actual.pristineValue,
			    isPristineValueEmpty = this.isPristineValueEmpty;

			return isPristineValueEmpty ? this.getDefaultStoreValue() : pristineValue;
		},
		set: function set(value) {
			var finalValue = this.getInputValue(value);
			this._actual.checkedStatus = 0;
			this._actual.pristineValue = finalValue;
			this.sourceValue = finalValue;
			if (this.applySetPristineValue) this.applySetPristineValue(finalValue);
			this._actual.value = finalValue;
			if (this.applySetValue) this.applySetValue(this.value);
			this.validate();
			return true;
		}
	}, {
		key: 'sourceValue',
		get: function get() {
			var sourceValue = this._actual.sourceValue,
			    isSourceValueEmpty = this.isSourceValueEmpty;

			return isSourceValueEmpty ? this.getDefaultStoreValue() : sourceValue;
		},
		set: function set(value) {
			this._actual.sourceValue = clone(value);
			return true;
		}
	}, {
		key: 'value',
		get: function get() {
			var value = this.applyGetValue();
			if (isObservableArray(value) && !isNativeArray(value)) return value.slice();
			return value;
		},
		set: function set(value) {
			this._actual.value = value;
			if (this.applySetValue) this.applySetValue(value);
			return true;
		}
	}, {
		key: 'errorMessage',
		get: function get() {
			var errorMessage = this._actual.errorMessage;

			var childErrorMessage = this.applyGetErrorMessage && this.applyGetErrorMessage();
			if (errorMessage) return errorMessage;
			return childErrorMessage || '';
		},
		set: function set(errorMessage) {
			this._actual.errorMessage = errorMessage;
			return true;
		}
	}, {
		key: 'isChecked',
		get: function get() {
			if (!this._checkable) return true;
			var _options = this._options,
			    parentStore = this.parentStore,
			    key = this.key,
			    value = this.value,
			    checkedStatus = this._actual.checkedStatus;

			var shouldChecked = parentStore.shouldCheck(key, value);
			if (checkedStatus) return checkedStatus > 0;
			if (parentStore.hasKey(key)) return shouldChecked;
			return _options.hasOwnProperty('defaultChecked') ? _options.defaultChecked : shouldChecked;
		},
		set: function set(checked) {
			/* istanbul ignore next */
			if (!this._checkable) return true;

			this._actual.checkedStatus = checked ? 1 : -1;
			return true;
		}
	}, {
		key: 'isPristineValueEmpty',
		get: function get() {
			return isEmpty(this._actual.pristineValue);
		}
	}, {
		key: 'isSourceValueEmpty',
		get: function get() {
			return isEmpty(this._actual.sourceValue);
		}
	}, {
		key: 'isValueEmpty',
		get: function get() {
			return isEmpty(this._actual.value);
		}
	}, {
		key: 'isValid',
		get: function get() {
			return !this.errorMessage;
		}
	}, {
		key: 'isInvalid',
		get: function get() {
			return !this.isValid;
		}
	}]);

	function PrimitiveStore(pristineValue, options) {
		var _this = this;

		_classCallCheck(this, PrimitiveStore);

		_initDefineProp(this, 'isTouched', _descriptor6, this);

		this._defaultValueFilter = function (value) {
			var _options = _this._options;

			if (_options.hasOwnProperty('defaultValue') && isEmpty(value)) {
				return _options.defaultValue;
			}
			return value;
		};

		this.submit = function () {
			var _form;

			return (_form = _this.form).submit.apply(_form, arguments);
		};

		this.reset = function () {
			var _form2;

			return (_form2 = _this.form).reset.apply(_form2, arguments);
		};

		this.clear = function () {
			var _form3;

			return (_form3 = _this.form).clear.apply(_form3, arguments);
		};

		var key = options.key,
		    parentStore = options.parentStore,
		    checkable = options.checkable,
		    isRadio = options.isRadio,
		    _options$form = options.form,
		    form = _options$form === undefined ? this : _options$form,
		    preFormat = options.preFormat,
		    format = options.format,
		    formatFunc = options.formatFunc,
		    inputFilter = options.inputFilter,
		    outputFilter = options.outputFilter,
		    enforceSubmit = options.enforceSubmit;

		var formatFilter = formatFunc || format && createFormatFunc(format);
		this.key = key;
		this.form = form;
		this.parentStore = parentStore;
		this._options = options;
		this.isRadio = isRadio;
		this.bus = {};
		this._actual = new Actual();
		this._checkable = checkable;
		this._preFormatFilter = preFormat;
		this._formatFilter = formatFilter;
		this._inputFilter = inputFilter;
		this._outputFilter = outputFilter;
		this._validation = new Validation(_extends({ formatFilter: formatFilter }, options));
		this._enforceSubmit = enforceSubmit;
		var initialValue = this.getInputValue(pristineValue);
		this._actual.setInitialValue(initialValue);
	}

	_createClass(PrimitiveStore, [{
		key: 'getDefaultStoreValue',
		value: function getDefaultStoreValue() {
			return this._options.hasOwnProperty('defaultValue') ? this._options.defaultValue : '';
		}
	}, {
		key: '_try',
		value: function _try(fn) {
			try {
				return runInAction(fn);
			} catch (error) {
				this.errorMessage = error.message || 'Invalid';
			}
		}
	}, {
		key: 'getOutputValue',
		value: function getOutputValue(value) {
			var _this2 = this;

			return this._try(function () {
				var pristineValue = _this2.pristineValue,
				    _outputFilter = _this2._outputFilter,
				    _preFormatFilter = _this2._preFormatFilter,
				    _formatFilter = _this2._formatFilter,
				    _defaultValueFilter = _this2._defaultValueFilter;

				return filtersFlow([_outputFilter, _preFormatFilter, _formatFilter, _defaultValueFilter], value, { pristineValue: pristineValue });
			});
		}
	}, {
		key: 'getInputValue',
		value: function getInputValue(value) {
			var _this3 = this;

			return this._try(function () {
				var _inputFilter = _this3._inputFilter,
				    _defaultValueFilter = _this3._defaultValueFilter;

				return filtersFlow([_inputFilter, _defaultValueFilter], value);
			});
		}
	}, {
		key: 'applyGetValue',
		value: function applyGetValue() {
			var isValueEmpty = this.isValueEmpty,
			    value = this._actual.value;

			return isValueEmpty ? this.getDefaultStoreValue() : value;
		}
	}, {
		key: 'getFormData',
		value: function getFormData() {
			var value = this.getOutputValue(this.value);
			return this.shouldIgnore(value) ? undefined : value;
		}
	}, {
		key: 'touch',
		value: function touch() {
			var isTouched = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

			this.isTouched = isTouched;
		}
	}, {
		key: 'validate',
		value: function validate() {
			var _this4 = this;

			if (!this.errorMessage) {
				this._try(function () {
					_this4._validation.exec(_this4.value);
					_this4.errorMessage = '';
				});
			}
		}
	}, {
		key: 'emitChange',
		value: function emitChange() {
			var _this5 = this;

			this._try(function () {
				_this5._validation.exec(_this5.value);
				_this5.isTouched = true;
				_this5.errorMessage = '';
				_this5.parentStore.change(_this5);
			});
		}
	}, {
		key: 'shouldIgnore',
		value: function shouldIgnore(value) {
			if (this._enforceSubmit || !this.isPristineValueEmpty) return false;
			if (isArray(value)) return !value.length;
			if (isPlainObject(value)) return !Object.keys(value).length;
			return isEmpty(value);
		}
	}, {
		key: 'getValidState',
		value: function getValidState() {
			var isValid = this.isValid,
			    isInvalid = this.isInvalid,
			    isTouched = this.isTouched,
			    errorMessage = this.errorMessage;

			return { isValid: isValid, isInvalid: isInvalid, isTouched: isTouched, errorMessage: errorMessage };
		}
	}]);

	return PrimitiveStore;
}(), (_descriptor6 = _applyDecoratedDescriptor(_class3.prototype, 'isTouched', [observable], {
	enumerable: true,
	initializer: function initializer() {
		return false;
	}
}), _applyDecoratedDescriptor(_class3.prototype, 'pristineValue', [computed], Object.getOwnPropertyDescriptor(_class3.prototype, 'pristineValue'), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, 'sourceValue', [computed], Object.getOwnPropertyDescriptor(_class3.prototype, 'sourceValue'), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, 'value', [computed], Object.getOwnPropertyDescriptor(_class3.prototype, 'value'), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, 'errorMessage', [computed], Object.getOwnPropertyDescriptor(_class3.prototype, 'errorMessage'), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, 'isChecked', [computed], Object.getOwnPropertyDescriptor(_class3.prototype, 'isChecked'), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, 'isPristineValueEmpty', [computed], Object.getOwnPropertyDescriptor(_class3.prototype, 'isPristineValueEmpty'), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, 'isSourceValueEmpty', [computed], Object.getOwnPropertyDescriptor(_class3.prototype, 'isSourceValueEmpty'), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, 'isValueEmpty', [computed], Object.getOwnPropertyDescriptor(_class3.prototype, 'isValueEmpty'), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, 'isValid', [computed], Object.getOwnPropertyDescriptor(_class3.prototype, 'isValid'), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, 'isInvalid', [computed], Object.getOwnPropertyDescriptor(_class3.prototype, 'isInvalid'), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, 'touch', [action], Object.getOwnPropertyDescriptor(_class3.prototype, 'touch'), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, 'emitChange', [action], Object.getOwnPropertyDescriptor(_class3.prototype, 'emitChange'), _class3.prototype)), _class3);
export { PrimitiveStore as default };