var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

import { isObservableArray } from 'mobx';
import warning from 'warning';

var uniqueId = 0;

var pad = function pad(target, length, fillString, calc) {
	var prev = target.toString();
	while (prev.length < length) {
		prev = calc(prev);
	}return prev;
};

export var noop = function noop() {};

export var isFunction = function isFunction(s) {
	return typeof s === 'function';
};
export var isNativeArray = function isNativeArray(s) {
	return s && s.constructor === Array;
};
export var isArray = function isArray(s) {
	return isNativeArray(s) || isObservableArray(s);
};
export var isEmpty = function isEmpty(s) {
	return !s && s !== false && s !== 0;
};
export var isString = function isString(s) {
	return typeof s === 'string';
};
export var isDate = function isDate(s) {
	return s && s.constructor === Date;
};
export var isObject = function isObject(s) {
	return (typeof s === 'undefined' ? 'undefined' : _typeof(s)) === 'object';
};
export var isPlainObject = function isPlainObject(s) {
	return !!s && isObject(s) && !isDate(s);
};

export var clone = function clone(s) {
	if (isArray(s)) return s.slice();
	if (isObject(s)) return _extends({}, s);
	return s;
};

export var createId = function createId(key) {
	return key + '[' + uniqueId++ + ']';
};

export var warn = function warn() {
	for (var _len = arguments.length, msgs = Array(_len), _key = 0; _key < _len; _key++) {
		msgs[_key] = arguments[_key];
	}

	return warning(false, '[react-form-mobx] ' + msgs.join(' '));
};

export var padEnd = function padEnd(target, length, fillString) {
	return pad(target, length, fillString, function (prev) {
		return '' + prev + fillString;
	});
};

export var padStart = function padStart(target, length, fillString) {
	return pad(target, length, fillString, function (prev) {
		return '' + fillString + prev;
	});
};

export var filtersFlow = function filtersFlow(filters, value, options) {
	filters = filters.filter(Boolean);
	var next = function next(value, options) {
		if (!filters.length) return value;
		var filter = filters.shift();
		return next(filter(value, options), options);
	};
	return next(value, options);
};