'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp, _class3, _class4, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mobxReact = require('mobx-react');

var _utils = require('./utils');

var _withFormStore = require('./withFormStore');

var _withFormStore2 = _interopRequireDefault(_withFormStore);

var _Demon = require('./Demon');

var _Demon2 = _interopRequireDefault(_Demon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var childrenType = _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.node]).isRequired;

var ItemGroup = (_dec = (0, _withFormStore2.default)(), _dec(_class = (0, _mobxReact.observer)(_class = (_temp = _class2 = function (_Component) {
	_inherits(ItemGroup, _Component);

	function ItemGroup(props) {
		_classCallCheck(this, ItemGroup);

		var _this = _possibleConstructorReturn(this, (ItemGroup.__proto__ || Object.getPrototypeOf(ItemGroup)).call(this, props));

		var formStore = props.formStore,
		    name = props.name,
		    children = props.children;

		var createId = function createId() {
			return (0, _utils.createId)(name);
		};
		var length = (0, _utils.isFunction)(children) ? formStore.sourceValue.length : _react.Children.count(children);

		_this.helper = {
			createId: createId,
			push: function push() {
				return formStore.push(createId());
			},
			remove: formStore.remove,
			removeBy: function removeBy(id) {
				return function () {
					return formStore.remove(id);
				};
			}
		};

		for (var i = 0; i < length; i++) {
			_this.helper.push();
		}
		return _this;
	}

	_createClass(ItemGroup, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    children = _props.children,
			    ids = _props.formStore.ids;

			if ((0, _utils.isFunction)(children)) return children(ids, this.helper);
			return _react.Children.map(children, function (child, index) {
				return (0, _react.cloneElement)(child, { name: ids[index] });
			});
		}
	}]);

	return ItemGroup;
}(_react.Component), _class2.propTypes = {
	formStore: _propTypes2.default.object.isRequired,
	children: childrenType,
	name: _propTypes2.default.string.isRequired
}, _temp)) || _class) || _class);

var ArrayOf = (0, _mobxReact.observer)(_class3 = (_temp2 = _class4 = function (_Component2) {
	_inherits(ArrayOf, _Component2);

	function ArrayOf(props) {
		_classCallCheck(this, ArrayOf);

		var _this2 = _possibleConstructorReturn(this, (ArrayOf.__proto__ || Object.getPrototypeOf(ArrayOf)).call(this, props));

		_this2.forwardedProps = {
			name: _this2.props.name
		};

		var children = props.children,
		    forwardedProps = _objectWithoutProperties(props, ['children']);

		_this2.forwardedProps = forwardedProps;
		return _this2;
	}

	_createClass(ArrayOf, [{
		key: 'getValue',
		value: function getValue() {
			return this.demon.getValue();
		}
	}, {
		key: 'setValue',
		value: function setValue(value) {
			this.demon.setValue(value);
		}
	}, {
		key: 'getPristineValue',
		value: function getPristineValue() {
			return this.demon.getPristineValue();
		}
	}, {
		key: 'setPristineValue',
		value: function setPristineValue(value) {
			this.demon.setPristineValue(value);
		}
	}, {
		key: 'getValidState',
		value: function getValidState() {
			return this.demon.getValidState();
		}
	}, {
		key: 'render',
		value: function render() {
			var _this3 = this;

			var _props2 = this.props,
			    children = _props2.children,
			    name = _props2.name;

			return _react2.default.createElement(
				_Demon2.default,
				{
					forwardedProps: this.forwardedProps,
					isObject: true,
					isArray: true,
					ref: function ref(demon) {
						return _this3.demon = demon;
					}
				},
				function () {
					return _react2.default.createElement(
						ItemGroup,
						{ name: name },
						children
					);
				}
			);
		}
	}]);

	return ArrayOf;
}(_react.Component), _class4.propTypes = {
	children: childrenType,
	name: _propTypes2.default.string.isRequired
}, _temp2)) || _class3;

exports.default = ArrayOf;