'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _mobx = require('mobx');

var _mobxReact = require('mobx-react');

var _FormStore = require('./FormStore');

var _FormStore2 = _interopRequireDefault(_FormStore);

var _Context = require('./Context');

var _Context2 = _interopRequireDefault(_Context);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Form = (0, _mobxReact.observer)(_class = (_temp = _class2 = function (_Component) {
	_inherits(Form, _Component);

	function Form(props) {
		_classCallCheck(this, Form);

		var _this = _possibleConstructorReturn(this, (Form.__proto__ || Object.getPrototypeOf(Form)).call(this, props));

		var onSubmit = props.onSubmit,
		    onValidChange = props.onValidChange,
		    onValid = props.onValid,
		    onInvalid = props.onInvalid,
		    onChange = props.onChange,
		    value = props.value,
		    inputFilter = props.inputFilter,
		    outputFilter = props.outputFilter;

		var formStore = new _FormStore2.default(value, {
			submit: onSubmit,
			change: onChange,
			isObject: true,
			inputFilter: inputFilter,
			outputFilter: outputFilter
		});
		_this.formStore = formStore;

		_this.removeValidListener = (0, _mobx.observe)(formStore, 'isValid', function (_ref) {
			var type = _ref.type,
			    newValue = _ref.newValue;

			/* istanbul ignore else */
			if (type === 'update') {
				onValidChange(newValue);
				newValue ? onValid() : onInvalid();
			}
		});
		return _this;
	}

	_createClass(Form, [{
		key: 'componentDidUpdate',
		value: function componentDidUpdate(prevProps) {
			var value = this.props.value;

			/* istanbul ignore else */

			if (prevProps.value !== value) {
				this.formStore.pristineValue = value;
				this.formStore.touch(false);
			}
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.removeValidListener();
		}
	}, {
		key: 'submit',
		value: function submit() {
			return this.formStore.submit();
		}
	}, {
		key: 'reset',
		value: function reset() {
			return this.formStore.reset();
		}
	}, {
		key: 'clear',
		value: function clear() {
			return this.formStore.clear();
		}
	}, {
		key: 'getValue',
		value: function getValue() {
			return this.formStore.value;
		}
	}, {
		key: 'setValue',
		value: function setValue(value) {
			this.formStore.value = value;
		}
	}, {
		key: 'getPristineValue',
		value: function getPristineValue() {
			return this.formStore.pristineValue;
		}
	}, {
		key: 'setPristineValue',
		value: function setPristineValue(value) {
			this.formStore.pristineValue = value;
		}
	}, {
		key: 'getValidState',
		value: function getValidState() {
			return this.formStore.getValidState();
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    Comp = _props.component,
			    value = _props.value,
			    onValidChange = _props.onValidChange,
			    onValid = _props.onValid,
			    onInvalid = _props.onInvalid,
			    onChange = _props.onChange,
			    inputFilter = _props.inputFilter,
			    outputFilter = _props.outputFilter,
			    other = _objectWithoutProperties(_props, ['component', 'value', 'onValidChange', 'onValid', 'onInvalid', 'onChange', 'inputFilter', 'outputFilter']);

			return _react2.default.createElement(
				_Context2.default.Provider,
				{ value: this.formStore },
				_react2.default.createElement(Comp, other)
			);
		}
	}]);

	return Form;
}(_react.Component), _class2.propTypes = {
	value: _propTypes.object,
	onSubmit: _propTypes.func,
	onValidChange: _propTypes.func,
	onValid: _propTypes.func,
	onInvalid: _propTypes.func,
	onChange: _propTypes.func,
	inputFilter: _propTypes.func,
	outputFilter: _propTypes.func,
	component: (0, _propTypes.oneOfType)([_propTypes.func, _propTypes.string, _propTypes.object])
}, _class2.defaultProps = {
	value: {},
	onSubmit: _utils.noop,
	onValidChange: _utils.noop,
	onValid: _utils.noop,
	onInvalid: _utils.noop,
	component: 'div'
}, _temp)) || _class;

exports.default = Form;