'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _desc, _value, _class, _descriptor, _descriptor2, _descriptor3;

var _mobx = require('mobx');

var _ObjectStore2 = require('./ObjectStore');

var _ObjectStore3 = _interopRequireDefault(_ObjectStore2);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _initDefineProp(target, property, descriptor, context) {
	if (!descriptor) return;
	Object.defineProperty(target, property, {
		enumerable: descriptor.enumerable,
		configurable: descriptor.configurable,
		writable: descriptor.writable,
		value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
	});
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
	var desc = {};
	Object['ke' + 'ys'](descriptor).forEach(function (key) {
		desc[key] = descriptor[key];
	});
	desc.enumerable = !!desc.enumerable;
	desc.configurable = !!desc.configurable;

	if ('value' in desc || desc.initializer) {
		desc.writable = true;
	}

	desc = decorators.slice().reverse().reduce(function (desc, decorator) {
		return decorator(target, property, desc) || desc;
	}, desc);

	if (context && desc.initializer !== void 0) {
		desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
		desc.initializer = undefined;
	}

	if (desc.initializer === void 0) {
		Object['define' + 'Property'](target, property, desc);
		desc = null;
	}

	return desc;
}

function _initializerWarningHelper(descriptor, context) {
	throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var ArrayStore = (_class = function (_ObjectStore) {
	_inherits(ArrayStore, _ObjectStore);

	function ArrayStore(pristineValue, options) {
		_classCallCheck(this, ArrayStore);

		var _this = _possibleConstructorReturn(this, (ArrayStore.__proto__ || Object.getPrototypeOf(ArrayStore)).call(this, pristineValue, options));

		_initDefineProp(_this, 'ids', _descriptor, _this);

		_this._index = 0;

		_initDefineProp(_this, 'push', _descriptor2, _this);

		_initDefineProp(_this, 'remove', _descriptor3, _this);

		_this._isRadioGroup = options.isRadioGroup;
		_this.children = (0, _mobx.observable)([]);
		return _this;
	}

	_createClass(ArrayStore, [{
		key: 'getDefaultStoreValue',
		value: function getDefaultStoreValue() {
			return [];
		}
	}, {
		key: 'applySetValue',
		value: function applySetValue(value) {
			this.eachChildren(function (child, index) {
				child.value = value[index];
			});
		}
	}, {
		key: 'applySetPristineValue',
		value: function applySetPristineValue() {
			var _this2 = this;

			this.isChecked = false;
			var keysToBeDeleted = [];
			var keysToBeAdded = this.sourceValue.slice(this.children.length);
			this.eachChildren(function (child, key) {
				if (key < _this2.sourceValue.length) {
					var val = _this2.sourceValue[key];
					child.pristineValue = val;
				} else {
					keysToBeDeleted.push(child.key);
				}
			});
			keysToBeDeleted.forEach(function (key) {
				_this2.detach(key);
				_this2.remove(key);
			});
			keysToBeAdded.forEach(function () {
				_this2.push((0, _utils.createId)(_this2.key));
			});
		}
	}, {
		key: 'getFormData',
		value: function getFormData() {
			var _this3 = this;

			var res = this.getDefaultStoreValue();
			this.eachChildren(function (child) {
				var val = child.getFormData();

				/* istanbul ignore else */
				if (!_this3.shouldIgnore(val)) res.push(val);
			});
			var value = this.getOutputValue(res);
			return this.shouldIgnore(value) ? undefined : value;
		}
	}, {
		key: '_findIndexByKey',
		value: function _findIndexByKey(key) {
			return this.children.findIndex(function (item) {
				return item.key === key;
			});
		}
	}, {
		key: 'eachChildren',
		value: function eachChildren(iterator) {
			var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
			var _options$checked = options.checked,
			    checked = _options$checked === undefined ? true : _options$checked;

			var filter = function filter(item) {
				return item.isChecked;
			};
			var index = 0;
			this.children.forEach(function (item, _) {
				for (var _len = arguments.length, args = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
					args[_key - 2] = arguments[_key];
				}

				if (!checked || filter(item)) iterator.apply(undefined, [item, index++].concat(args));
			});
		}
	}, {
		key: 'getChildren',
		value: function getChildren(key) {
			var index = this._findIndexByKey(key);
			if (~index) return this.children[index];
		}
	}, {
		key: 'setChildren',
		value: function setChildren(key, store) {
			var index = this._findIndexByKey(key);

			/* istanbul ignore else */
			if (index < 0) index = this.children.length;

			this.children[index] = store;
			return true;
		}
	}, {
		key: 'shouldCheck',
		value: function shouldCheck(key, value) {
			var sourceValue = this.sourceValue;

			var checked = !!~sourceValue.indexOf(value);
			if (checked) return checked;
			if (value === true) return !!~sourceValue.indexOf('true');
			return false;
		}
	}, {
		key: 'hasKey',
		value: function hasKey(key) {
			if (this._isRadioGroup) return this.parentStore.hasKey(this.key);

			var matched = false;
			this.eachChildren(function (child) {
				if (!matched) matched = key === child.key;
			}, { checked: false });
			return matched;
		}
	}, {
		key: 'attach',
		value: function attach(key, options) {
			var sourceValue = this.sourceValue,
			    form = this.form;
			var isRadioGroup = options.isRadioGroup;

			var index = isRadioGroup ? --this._index : this._index++;
			var value = index >= sourceValue.length ? '' : sourceValue[index];
			return form.createChildren(this, key, value, options);
		}
	}, {
		key: 'detach',
		value: function detach(key) {
			var index = this._findIndexByKey(key);
			if (index < 0) return;
			this.sourceValue.splice(index, 1);
			this.children.splice(index, 1);
		}
	}, {
		key: 'checkKey',
		value: function checkKey(key) {
			this.eachChildren(function (child) {
				if (child.isChecked && child.key !== key) {
					child.isChecked = false;
				}
			}, { checked: false });
		}
	}]);

	return ArrayStore;
}(_ObjectStore3.default), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'ids', [_mobx.observable], {
	enumerable: true,
	initializer: function initializer() {
		return [];
	}
}), _applyDecoratedDescriptor(_class.prototype, 'applySetValue', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'applySetValue'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'applySetPristineValue', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'applySetPristineValue'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setChildren', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setChildren'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'attach', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'attach'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'detach', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'detach'), _class.prototype), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, 'push', [_mobx.action], {
	enumerable: true,
	initializer: function initializer() {
		var _this4 = this;

		return function (id) {
			return _this4.ids.push(id);
		};
	}
}), _descriptor3 = _applyDecoratedDescriptor(_class.prototype, 'remove', [_mobx.action], {
	enumerable: true,
	initializer: function initializer() {
		var _this5 = this;

		return function (id) {
			var removed = _this5.ids.remove(id);

			/* istanbul ignore else */
			if (removed) _this5._index--;

			return removed;
		};
	}
}), _applyDecoratedDescriptor(_class.prototype, 'checkKey', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'checkKey'), _class.prototype)), _class);
exports.default = ArrayStore;