'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.filtersFlow = exports.padStart = exports.padEnd = exports.warn = exports.createId = exports.clone = exports.isPlainObject = exports.isObject = exports.isDate = exports.isString = exports.isEmpty = exports.isArray = exports.isNativeArray = exports.isFunction = exports.noop = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _mobx = require('mobx');

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var uniqueId = 0;

var pad = function pad(target, length, fillString, calc) {
	var prev = target.toString();
	while (prev.length < length) {
		prev = calc(prev);
	}return prev;
};

var noop = exports.noop = function noop() {};

var isFunction = exports.isFunction = function isFunction(s) {
	return typeof s === 'function';
};
var isNativeArray = exports.isNativeArray = function isNativeArray(s) {
	return s && s.constructor === Array;
};
var isArray = exports.isArray = function isArray(s) {
	return isNativeArray(s) || (0, _mobx.isObservableArray)(s);
};
var isEmpty = exports.isEmpty = function isEmpty(s) {
	return !s && s !== false && s !== 0;
};
var isString = exports.isString = function isString(s) {
	return typeof s === 'string';
};
var isDate = exports.isDate = function isDate(s) {
	return s && s.constructor === Date;
};
var isObject = exports.isObject = function isObject(s) {
	return (typeof s === 'undefined' ? 'undefined' : _typeof(s)) === 'object';
};
var isPlainObject = exports.isPlainObject = function isPlainObject(s) {
	return !!s && isObject(s) && !isDate(s);
};

var clone = exports.clone = function clone(s) {
	if (isArray(s)) return s.slice();
	if (isObject(s)) return _extends({}, s);
	return s;
};

var createId = exports.createId = function createId(key) {
	return key + '[' + uniqueId++ + ']';
};

var warn = exports.warn = function warn() {
	for (var _len = arguments.length, msgs = Array(_len), _key = 0; _key < _len; _key++) {
		msgs[_key] = arguments[_key];
	}

	return (0, _warning2.default)(false, '[react-form-mobx] ' + msgs.join(' '));
};

var padEnd = exports.padEnd = function padEnd(target, length, fillString) {
	return pad(target, length, fillString, function (prev) {
		return '' + prev + fillString;
	});
};

var padStart = exports.padStart = function padStart(target, length, fillString) {
	return pad(target, length, fillString, function (prev) {
		return '' + fillString + prev;
	});
};

var filtersFlow = exports.filtersFlow = function filtersFlow(filters, value, options) {
	filters = filters.filter(Boolean);
	var next = function next(value, options) {
		if (!filters.length) return value;
		var filter = filters.shift();
		return next(filter(value, options), options);
	};
	return next(value, options);
};